
-- CotW AI functions --

local M = {}

local function estDistCost(map, x1, y1, x2, y2)
	return (math.abs(x1-x2) + math.abs(y1-y2)) * map.avgCost
end

local function insertTable(list, row, value)
	local lastRow = #list + 1
	for n = lastRow, row + 1, -1 do
		list[n] = list[n-1]
	end
	list[row] = value
	return list
end


function M.pathfind(map, x1, y1, x2, y2) -- A*

-- HACK ***
if x1 == x2 and y1 == y2 then
	print("Poop! Tried to pathfind into self!!")
	return nil
end
--~ print(" ")
--~ print(" pathfind: ("..tostring(x1)..","..tostring(y1)..") to ("..tostring(x2)..","..tostring(y2)..")") -- *****
-- HACK ***


	-- Initialize pathfinding
	local dirs = {{-1,0}, {0,-1}, {1,0}, {0,1}}
	local openList = {{x=x1, y=y1, f=estDistCost(map, x1, y1, x2, y2), g=0, h=estDistCost(map, x1, y1, x2, y2)}}
	local closedList  = {}
	for x = 1, map.w do
		closedList[x] = {} -- Represent closedList as a 2D grid for simpler checking
	end

	-- loop through openList
	repeat
		-- Pull the best cell (last cell in list)
		local n = openList[#openList]
		openList[#openList] = nil
		-- put it on closedList
		closedList[n.x][n.y] = {f=n.f, px=n.px, py=n.py}
		-- Examine the 4 neighbor cells
		for i,d in pairs(dirs) do
			local cellX, cellY = n.x + d[1], n.y + d[2]
			-- *** WATCH FOR DOORS etc!!!
			if map[cellX] and map[cellX][cellY] then
				-- compute cell's score
				local score = {}
				score.g = n.g + map[cellX][cellY].pathCost
				score.h = estDistCost(map, cellX, cellY, x2, y2)
				score.f = score.g + score.h
				-- check closedList
				if closedList[cellX][cellY] and score.f < closedList[cellX][cellY].f then closedList[cellX][cellY] = nil end
				-- check openList
				local row
				for j = 1, #openList do
					if cellX == openList[j].x and cellY == openList[j].y then row = j end
				end
				-- insert new cell into openList
				if not (closedList[cellX][cellY] or row) then
					row = 0
					repeat
						row = row + 1
					until row > #openList or score.f > openList[row].f
					openList = insertTable(openList, row, {x=cellX, y=cellY, px=n.x, py=n.y, f=score.f, g=score.g, h=score.h})
				end
			end
		end
	until closedList[x2][y2] or #openList == 0

	-- Build path
	local path = nil
	if closedList[x2][y2] then
		path = {cost=0}
		path[1] = {x=x2, y=y2}
		repeat
			local x = path[#path].x
			local y = path[#path].y
			path[#path+1] = {x=closedList[x][y].px, y=closedList[x][y].py}
			path.cost = path.cost + closedList[x][y].f
		until path[#path].x == x1 and path[#path].y == y1
	end
	return path
end

return M
